%Last updated: July 27, 2010 - 11:15am
function BPMrealtime

%%
%Pre-Initialization Tasks
x1 = 400;
y1 = 450;
x2 = 700;
y2 = 700;

w_abcd = 0.43;  %width of axes
h_abcd = 0.4;   %height of axes
vs_abcd = .07;  %veertical spacing in between axes
hs_abcd = .05;  %horizontal spacing in between axes

w_xysum = 0.43;  %width of axes
h_xysum = 0.4;   %height of axes
vs_xysum = .07;  %veertical spacing in between axes
hs_xysum = .05;  %horizontal spacing in between axes

console = figure(1);
clf(console,'reset');
set(console, 'NumberTitle', 'off',...
    'Name', 'BPM Console Window',...    
    'Position', [0 500 x1 y1], ...
    'Resize', 'on', ...
    'ToolBar', 'none',...
    'MenuBar', 'none',...
    'Visible', 'on');
graphs_abcd = figure(2);
clf(graphs_abcd,'reset');
set(graphs_abcd, 'NumberTitle', 'off',...
    'Name', 'BPM Graphs - Channel readings',...
    'Position', [400 250 x2 y2], ...
    'Resize', 'on', ...
    'ToolBar', 'figure',...
    'MenuBar', 'none',...
    'Visible', 'on');
graphs_xysum = figure(3);
clf(graphs_xysum,'reset');
set(graphs_xysum, 'NumberTitle', 'off',...
    'Name', 'BPM Graphs - Slow Acquisition',...
    'Position', [400 200 x2 y2], ...
    'Resize', 'on', ...
    'ToolBar', 'figure',...
    'MenuBar', 'none',...
    'Visible', 'on');

serialport = 'Com1';
otherselect = 0;
object_created = 0;
bpm = [];
go = 1;
data = [];
windows = [0 0];

%%
%Construct the components
serialselect = uibuttongroup('parent', console, ...
    'title', 'Serial Port Select', ...
    'fontsize', 12, ...
    'titleposition', 'centertop', ...
    'units', 'pixels', ...
    'Position', [x1*.01 385 x1*.98 60]);
serialselect_com1 = uicontrol('Parent', serialselect, ...
    'Style', 'radiobutton', ...
    'HorizontalAlignment', 'left', ...
    'String', 'COM1', ...
    'fontsize', 10, ...
    'Value', false,...
    'Units', 'normalized', ...
    'Position', [.025 .65 .3 .35]);
serialselect_com2 = uicontrol('Parent', serialselect, ...
    'Style', 'radiobutton', ...
    'HorizontalAlignment', 'left', ...
    'String', 'COM2', ...
    'fontsize', 10, ...
    'Value', false,...
    'Units', 'normalized', ...
    'Position', [.35 .65 .3 .35]);
serialselect_com3 = uicontrol('Parent', serialselect, ...
    'Style', 'radiobutton', ...
    'HorizontalAlignment', 'left', ...
    'String', 'COM3', ...
    'fontsize', 10, ...
    'Value', false,...
    'Units', 'normalized', ...
    'Position', [.675 .65 .3 .35]);
serialselect_other = uicontrol('Parent', serialselect, ...
    'Style', 'radiobutton', ...
    'HorizontalAlignment', 'left', ...
    'String', 'Other:', ...
    'fontsize', 10, ...
    'Value', false,...
    'Units', 'normalized', ...
    'Position', [.025 .1 .3 .35]);
serialselect_otherinput = uicontrol('Parent', serialselect, ...
    'Style', 'edit', ...
    'HorizontalAlignment', 'left', ...
    'Enable', 'off', ...
    'String', '', ...
    'fontsize', 10, ...
    'Units', 'normalized', ...
    'Position', [.25 .08 .5 .5], ...
    'ToolTipString', 'Type in as ''ComX'', etc');
% get(serialselect_otherinput)
command = uipanel('Parent', console, ...
    'Title', 'Enter Command', ...
    'FontSize', 12, ...
    'TitlePosition', 'centertop', ...
    'Units', 'pixels', ...
    'Position', [x1*.01 310 x1*.98 70]);
command_string = uicontrol('Parent', command, ...
    'Style', 'edit', ...
    'String', '', ...
    'Enable', 'on', ...
    'BackgroundColor', [1 1 1], ...
    'HorizontalAlignment', 'left', ...
    'FontSize', 8, ...
    'Units', 'normalized', ...
    'Position', [.01 .6 .98 .4]);
command_setbutton = uicontrol('Parent', command, ...
    'Style', 'pushbutton',...
    'String', 'Set', ...
    'HorizontalAlignment', 'center',...
    'Units', 'normalized', ...
    'Position', [.025 .1 .2 .4], ...
    'Tooltipstring', 'Send a command to the BPM to adjust settings');
command_collectbutton = uicontrol('Parent', command, ...
    'Style', 'pushbutton',...
    'String', 'Collect data', ...
    'HorizontalAlignment', 'center',...
    'Units', 'normalized', ...
    'Position', [.275 .1 .225 .4], ...
    'Tooltipstring', 'Begin real-time data collection');
command_stopbutton = uicontrol('Parent', command, ...
    'Style', 'pushbutton',...
    'String', 'Stop', ...
    'HorizontalAlignment', 'center',...
    'Units', 'normalized', ...
    'Position', [.55 .1 .2 .4], ...
    'Tooltipstring', 'Stop collecting data. Closes serial line');
command_savebutton = uicontrol('Parent', command, ...
    'Style', 'pushbutton',...
    'String', 'Save', ...
    'HorizontalAlignment', 'center',...
    'Units', 'normalized', ...
    'Position', [.8 .1 .15 .4], ...
    'Tooltipstring', 'Save data to file. Make sure to stop before saving.');
response = uipanel('Parent', console, ...
    'Title', 'BPM Response', ...
    'TitlePosition', 'centertop', ...
    'FontSize', 12, ...
    'Units', 'pixels', ...
    'Position', [x1*.01 5 x1*.98 300]);
response_out = uicontrol('Parent', response', ...
    'Style', 'text', ...
    'FontSize', 8, ...
    'String', 'No response', ...
    'HorizontalAlignment', 'left', ...
    'BackgroundColor' , [.9 .9 .9], ...
    'Units', 'normalized', ...
    'Position', [.01 .01 .98 .98]);

graph_channelA = axes('Parent', graphs_abcd, ...
    'Units', 'normalized', ...
    'Position', [hs_abcd (2*vs_abcd+h_abcd) w_abcd h_abcd]);
title(graph_channelA, 'Channel A');
graph_channelB = axes('Parent', graphs_abcd, ...
    'Units', 'normalized', ...
    'Position', [(2*hs_abcd+w_abcd) (2*vs_abcd+h_abcd) w_abcd h_abcd]);
title(graph_channelB, 'Channel B');
graph_channelC = axes('Parent', graphs_abcd, ...
    'Units', 'normalized', ...
    'Position', [hs_abcd vs_abcd w_abcd h_abcd]);
title(graph_channelC, 'Channel C');
graph_channelD = axes('Parent', graphs_abcd, ...
    'Units', 'normalized', ...
    'Position', [(2*hs_abcd+w_abcd) vs_abcd w_abcd h_abcd]);
title(graph_channelD, 'Channel D');

graph_xpos = axes('Parent', graphs_xysum, ...
    'Units', 'normalized', ...
    'Position', [hs_xysum (2*vs_xysum+h_xysum) w_xysum h_xysum]);
title(graph_xpos, 'SA X Position');
graph_ypos = axes('Parent', graphs_xysum, ...
    'Units', 'normalized', ...
    'Position', [(2*hs_xysum+w_xysum) (2*vs_xysum+h_xysum) w_xysum h_xysum]);
title(graph_ypos, 'SA Y Position');
graph_xysum = axes('Parent', graphs_xysum, ...
    'Units', 'normalized', ...
    'Position', [hs_xysum .05 w_xysum h_xysum]);
title(graph_xysum, 'SA XY Sum');
savebutton = uicontrol('Parent', graphs_xysum, ...
    'Style', 'pushbutton', ...
    'String', 'Save data to file', ...
    'FontSize', 14, ...
    'Units', 'normalized', ...
    'Position', [(2*hs_xysum+w_xysum) .2 w_xysum .2]);
%%
%Post-Initialization Tasks

%%
%Callbacks
set(serialselect_com1, 'Callback', @serialselect_callback);    
set(serialselect_com2, 'Callback', @serialselect_callback);   
set(serialselect_com3, 'Callback', @serialselect_callback);   
set(serialselect_other, 'Callback', @serialselect_callback);  
set(command_setbutton, 'Callback', @set_bpm);
set(command_collectbutton, 'Callback', @collect_bpm);
set(command_savebutton, 'Callback', @save_bpm);
set(command_stopbutton, 'Callback', @stop_bpm);
set(savebutton, 'Callback', @save_bpm);
set(console, 'CloseRequestFcn', @close_figure);
set(graphs_abcd, 'DeleteFcn', @close_graph);
set(graphs_xysum, 'DeleteFcn', @close_graph);
%%
%Utility Functions
    function serial_object
        if (object_created == 0)    %serial object hasn't been created
            if(otherselect) %"Other" selected for com port
                serialport = get(serialselect_otherinput, 'String')
            end
            bpm = serial(serialport, {'Baudrate', 'Parity', 'DataBits', ...
                'StopBits', 'Flowcontrol', 'ReadAsyncMode'}, {[115200], ...
                'none', [8], [1], 'none', 'continuous'});
            set(bpm, 'InputBufferSize', 10000);
            object_created = 1;
        end        
    end
        
    function set_bpm(hObject, eventdata)
        %Check if serial object already exists. If not create it and assert
        %flag
        serial_object;        
        %Check whether serial channel is open
        if(strcmp(bpm.Status,'closed'))
            fopen(bpm);
        end     %else channel already open so no need to open
        request = get(command_string, 'String');
        fwrite(bpm, [request,char(13)], 'uchar');
        pause(0.1);
        response = fread(bpm, bpm.bytesavailable, 'uchar');
        response = char(response');
        set(response_out, 'String', response);
        set(command_string, 'String', '');
    end

    function collect_bpm(hObject, eventdata)
        %Check if serial object already exists. If not create it and assert
        %flag
        serial_object;
        if(strcmp(bpm.Status,'closed'))
            fopen(bpm);
        end     %else channel already open so no need to open
        go = 1;
        request = ['sa', char(13)]
        result = []
        flag_plot = 0
        c = -9
        temp_data = []
        while(go)          
            %tic
            fwrite(bpm, [request,char(13)], 'uchar')
            pause(0.1)           
            if((go == 0) || (bpm.bytesavailable <87))
                continue;
            end
            pause(0.2)
            response = fread(bpm, bpm.bytesavailable, 'uchar');
            response = response';            
            index_cr = find(response == 13, 2);
            %pause(0.1);
            valid = response(1,(index_cr(1)+1):index_cr(2)-1);
            if (length(valid) < 60)
                continue;
            end
            temp_data = str2num(char(valid));
            data = [data; temp_data];
            flag_plot = flag_plot+1;           
            if (flag_plot == 10) %after collecting 10 samples plot data                                
                c = c+10;
                data;
                temp = [c:c+9]'
                axes(graph_channelA); 
                hold on;
                title('Channel A');
                plot(temp,data(c:c+9,1), 'b.');                
                axes(graph_channelB); 
                hold on;
                title('Channel B');
                plot(temp,data(c:c+9,2), 'b.');             
                axes(graph_channelC); 
                hold on;
                title('Channel C');
                plot(temp,data(c:c+9,3), 'b.');              
                axes(graph_channelD); 
                hold on;
                title('Channel D');
                plot(temp,data(c:c+9,4), 'b.');              
                axes(graph_xpos); 
                hold on;
                title('SA X position');
                plot(temp,data(c:c+9,5), 'b.');                
                axes(graph_ypos); 
                hold on;
                title('SA Y position');
                plot(temp,data(c:c+9,6), 'b.');                
                axes(graph_xysum); 
                hold on;
                title('SA XY sum');
                plot(temp,data(c:c+9,7), 'b.'); 
                flag_plot = 0;  %reset flag variable for future 
            end
            hold off;
%             if (bpm.bytesavailable > 87)
%                 flushinput(bpm);
%             end
            %result = [result toc];   %used to assess timing performance
        end
        
    end

    function stop_bpm(hObject, eventdata)
        %Check if serial object already exists. If so close and destroy
        if(object_created == 1)
            go = 0;
            pause(1)
            if(strcmp(bpm.Status,'open'))
                fclose(bpm);
            end
            delete(bpm);
            object_created = 0;
            msgbox('Serial channel to BPM closed succesfully', 'Connection closed', 'modal');
        else
            go = 0;
            msgbox('Not connected to BPM', 'Error', 'modal');
          
        end    
        
    end

    function save_bpm(hObject, eventdata)
        %User prompt
        selection = questdlg(['All data collected before post-processing will'...
            ' be saved and discarded for new collection. Continue?'],...
            'Post Process?', 'Yes', 'No', 'Yes');
        if strcmp(selection, 'No')
            return;
        end
        %User selected yes, so do something
        output = data
        [rows cols] = size(output);
        %Obtain file name and path for saving output
        [filename, pathname, filterindex] = uiputfile( ...  %obtain filename and path
            {'*.dat','DAT-files (*.dat)'; ...               %for saving file
            '*.txt','Text (*.txt)'; ...
            '*.*',  'All Files (*.*)'}, ...
            'Save output as', 'Output.dat');
        %determine whether or not user selected 'Cancel'
        if isequal(filename,0) || isequal(pathname,0)
            return
        else    %user didn't select 'Cancel'
            %create/open file for writing
            file = fopen([pathname filename],'w');
            %get system date and time for header
            c = clock;
            %write file header to file
            fprintf(file,'$HEAD DATA COEFF %d-%d-%d %d:%d:%d:00 -- Head description\n\n',c(2),c(3),c(1),c(4),c(5),round(c(6)));
            %write output values (gain coeffs) to file, line by line
            for i=1:rows
                fprintf(file, '%d\t%d\t%d\t%d\t%d\t%d\t%d\n', [data(i,:)]);
            end
            %close file after data writing is complete
            fclose(file);
            %rest data matrix for next series of data
            data = [];
        end
    end

    function save_graphs(hObject, eventdata)
        directory = uigetdir('', 'Select root directory for graphs')       
        %determine whether or not user selected 'Cancel'
        if isequal(directory,0)
            return
        else    %user didn't select 'Cancel'
            temp = figure('visible', 'off')
            tempax = copyobj(graph_channelA, temp);
            hgsave(temp,'Channel A') % save it
%             saveas(graph_channelA, 'Channel A', 'fig');
%             saveas(graph_channelB, 'Channel B', 'fig');
%             saveas(graph_channelC, 'Channel C', 'fig');
%             saveas(graph_channelD, 'Channel D', 'fig');
%             saveas(graph_xpos, 'SA X Position', 'fig');
%             saveas(graph_ypos, 'SA Y Position', 'fig');
%             saveas(graph_xysum, 'SA XY Sum', 'fig');
            %             %get system date and time for folder title
%             c = clock;
%             if (c(4) >= 12)
%                 meridiem = 'PM';
%             else
%                 meridiem = 'AM';
%             end
%             if (c(5) < 10)
%                 minutes = ['0' num2str(c(5))];
%             else
%                 minutes = num2str(c(5));
%             end
%             date = [num2str(c(2)) '-' num2str(c(3)) '-' num2str(c(1)) ...
%                 ', ' num2str(mod(c(4),12)) ':' minutes meridiem];
%             savedir = ['RTP Graphs ' date]
%             mkdir(directory, savedir);

        end
    end

    function serialselect_callback(hObject, eventdata)
        if (get(serialselect_com1, 'Value') == 1)
            otherselect = 0;
            serialport = 'COM1';
            set(serialselect_otherinput, 'Enable', 'off',...
                'BackgroundColor', [0.878431 0.87451 0.890196]);
        elseif (get(serialselect_com2, 'Value') == 1)
            otherselect = 0;
            serialport = 'COM2';
            set(serialselect_otherinput, 'Enable', 'off',...
                'BackgroundColor', [0.878431 0.87451 0.890196]);
        elseif (get(serialselect_com3, 'Value') == 1)
            otherselect = 0;
            serialport = 'COM3';
            set(serialselect_otherinput, 'Enable', 'off',...
                'BackgroundColor', [0.878431 0.87451 0.890196]);
        elseif (get(serialselect_other, 'Value') == 1)
            otherselect = 1;
            serialport = '';
            set(serialselect_otherinput, 'Enable', 'on',...
                'BackgroundColor', [1 1 1]);
        end          
    end

    function close_graph(hObject, eventdata)
        name = get(hObject, 'Name');
        if (strcmp(name, 'BPM Graphs - Channel readings'))
            windows(1) = 1;
        elseif (strcmp(name, 'BPM Graphs - Slow Acquisition'))
            windows(2) = 1;
        else 
            windows = [0 0];
        end
    end
         

    function close_figure(hObject, eventdata)
        selection = questdlg('Would you like to exit? (any unsaved data will be lost)',...
            'Exit program?', 'Yes', 'No', 'Yes');
        if strcmp(selection, 'No')
            return;
        end
        %Close figures
        if (~windows(1) && ~windows(2)) %all windows are open
            delete(graphs_abcd);
            delete(graphs_xysum);
            delete(console);
        elseif (~windows(1) && windows(2)) %xysum is closed
            delete(graphs_abcd);
            delete(console);
        elseif (windows(1) && ~windows(2)) %abcd is closed
            delete(graphs_xysum);
            delete(console);
        else    %both graphing windows are closed
            delete(console);
        end        
    end
    
end
