function MB_DDR2AddressSel(addroffset)
%MODBUS DDR2 Address Select
%Sets offset address into DDR2
%  Addr = 0   =>  0x0000:0000 ADC raw data
%  Addr = 1   =>  0x0100:0000 IQ Data
%FC=10 : Write Multiple Registers
t = tcpip('192.168.70.1',502);
set (t, 'InputBufferSize', 65000);
fopen(t);
%set up request packet for 100 bytes
header = [0 0 0 0];
length = [0 9];
targ_id = 1;
func_code = 16;
addr = [0 52]   %MB_ADDR__DDR2_OFFSET_H  (cmd_modbus.h)
word_cnt = [0 1];
byte_cnt = 2;
reg_val = [addroffset 0]  
command = [header length targ_id func_code addr word_cnt byte_cnt reg_val]
%header = [0 0  0 0  0 6  1 4 0 0 0 100]
fwrite(t, command,'uint8');

disp('Pausing...')
pause(1);
disp('Reading....')

%Receive data from microblaze MODBUS server
bytes_rcvd = get(t, 'BytesAvailable')
DataReceived = fread(t,bytes_rcvd,'uint8')

fclose(t);
disp('done')
